> ## Documentation Index
> Fetch the complete documentation index at: https://aisa.one/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List Flight Offers

> List offers across searches (paginated)



## OpenAPI

````yaml openapi/zh/duffel-flights.json GET /apis/v1/duffel/flights/offers/list
openapi: 3.1.0
info:
  description: ''
  title: Duffel Flights
  version: '1'
  x-aisa-capabilities:
    idempotency: Idempotency-Key
    max_price: X-AISA-Max-Price-USD
    quote:
      header: X-AISA-Cost-Mode
      value: quote
  x-aisa-configured-paths:
    - /apis/v1/duffel/flights/offer-requests/create
    - /apis/v1/duffel/flights/offer-requests/list
    - /apis/v1/duffel/flights/offer-requests/{id}
    - /apis/v1/duffel/flights/offers/list
    - /apis/v1/duffel/flights/offers/{id}
    - /apis/v1/duffel/flights/order-cancellations/create
    - /apis/v1/duffel/flights/order-cancellations/{id}
    - /apis/v1/duffel/flights/order-cancellations/{id}/confirm
    - /apis/v1/duffel/flights/order-change-requests/create
    - /apis/v1/duffel/flights/order-change-requests/{id}
    - /apis/v1/duffel/flights/order-changes/create
    - /apis/v1/duffel/flights/orders/create
    - /apis/v1/duffel/flights/orders/hold-create
    - /apis/v1/duffel/flights/seat-maps
  x-aisa-document:
    facts_hash: f5da5a328e1cec5e66cbcd1109d12fa71687c2c4e8bd1da8db603ed7bccd6637
    generator_version: '2'
    protocol_version: '1'
    schema_version: '1'
    composer_version: '13'
    response_pending:
      - operation_id: post_duffel_offer_requests_create
        path: /apis/v1/duffel/flights/offer-requests/create
        method: POST
        statuses:
          - '200'
        reason: public success response has no authoritative payload declaration
      - operation_id: get_duffel_offer_request
        path: /apis/v1/duffel/flights/offer-requests/{id}
        method: GET
        statuses:
          - '200'
        reason: public success response has no authoritative payload declaration
    document_hash: sha256:bede2cc04d9a6a5b3f07d39c9a84e32a4c2c99be12c3c7e14b9df2ff3c3a3d8a
  x-aisa-plans:
    builder: 1
    display_plan: payg
    payg: 1
    similarweb_payg: 1
    team: 1
    version: e70a0959cd1b93b84ae16dffd7a538273ddb9c1d46277b82823c37ff1b6bc0fb
  x-aisa-provider: duffel-flights
  x-aisa-catalogs:
    duffel-flights:
      title: Duffel Flights
      description: ''
      x-aisa-document:
        facts_hash: f5da5a328e1cec5e66cbcd1109d12fa71687c2c4e8bd1da8db603ed7bccd6637
        generator_version: '2'
        protocol_version: '1'
        schema_version: '1'
      x-aisa-plans:
        builder: 1
        display_plan: payg
        payg: 1
        similarweb_payg: 1
        team: 1
        version: e70a0959cd1b93b84ae16dffd7a538273ddb9c1d46277b82823c37ff1b6bc0fb
      x-aisa-capabilities:
        idempotency: Idempotency-Key
        max_price: X-AISA-Max-Price-USD
        quote:
          header: X-AISA-Cost-Mode
          value: quote
servers:
  - url: https://api.aisa.one
security:
  - bearerAuth: []
paths:
  /apis/v1/duffel/flights/offers/list:
    get:
      tags:
        - duffel
      summary: List Flight Offers
      description: List offers across searches (paginated)
      operationId: get_duffel_offers_list
      parameters:
        - in: query
          name: after
          required: false
          schema:
            type: string
        - in: query
          name: before
          required: false
          schema:
            type: string
        - in: query
          name: limit
          required: false
          schema:
            maximum: 200
            minimum: 1
            type: integer
        - in: query
          name: offer_id
          required: false
          schema:
            type: string
      responses:
        default:
          content:
            application/json:
              schema: {}
          description: >-
            Error response; upstream passthrough responses may use provider
            formats
        2XX:
          content:
            application/json:
              schema:
                type: object
                required:
                  - data
                properties:
                  data:
                    type: array
                    items:
                      properties:
                        available_airline_credit_ids:
                          description: >-
                            The IDs of airline credits that can be used to pay
                            for this offer. Each ID represents a credit that can
                            be applied as a payment method when creating an
                            order from this offer.
                          example:
                            - acd_00009htYpSCXrwaB9DnUm1
                            - acd_00009htYpSCXrwaB9DnUm2
                          items:
                            type: string
                          type: array
                        available_services:
                          description: >-
                            The services that can be booked along with the offer
                            but are not included by default, for example an
                            additional checked bag. This field is only returned
                            in the [Get single
                            offer](/docs/api/offers/get-offer-by-id) endpoint.
                            When there are no services available, or we don't
                            support services for the airline, this list will be
                            empty. If you want to know which airlines we support
                            services for, please get in touch with the Duffel
                            support team at <help@duffel.com>.
                          items:
                            properties:
                              id:
                                description: Duffel's unique identifier for the resource
                                example: ase_00009UhD4ongolulWd9123
                                type: string
                              maximum_quantity:
                                description: >-
                                  The maximum quantity of this service that can
                                  be booked with an order
                                example: 1
                                minimum: 1
                                type: integer
                              metadata:
                                description: >
                                  The metadata varies by the type of service. It
                                  includes further data

                                  about the service. For example, for baggages,
                                  it may have data about

                                  size and weight restrictions.
                                oneOf:
                                  - additionalProperties: false
                                    description: >-
                                      An object containing metadata about the
                                      service, like the maximum weight and
                                      dimensions of the baggage.
                                    properties:
                                      maximum_depth_cm:
                                        description: >-
                                          The maximum depth that the baggage can
                                          have in centimetres
                                        example: 75
                                        type:
                                          - number
                                          - 'null'
                                      maximum_height_cm:
                                        description: >-
                                          The maximum height that the baggage can
                                          have in centimetres
                                        example: 90
                                        type:
                                          - number
                                          - 'null'
                                      maximum_length_cm:
                                        description: >-
                                          The maximum length that the baggage can
                                          have in centimetres
                                        example: 90
                                        type:
                                          - number
                                          - 'null'
                                      maximum_weight_kg:
                                        description: >-
                                          The maximum weight that the baggage can
                                          have in kilograms
                                        example: 23
                                        type:
                                          - number
                                          - 'null'
                                      type:
                                        description: The type of the baggage
                                        enum:
                                          - checked
                                          - carry_on
                                        example: checked
                                        type: string
                                    required:
                                      - type
                                    title: Service Metadata for a Baggage
                                    type: object
                                  - additionalProperties: false
                                    description: >
                                      An object containing metadata about the
                                      service, like the designator of the 

                                      seat.
                                    example:
                                      designator: 14B
                                      disclosures:
                                        - Do not seat children in exit row seats
                                        - >-
                                          Do not seat passengers with special
                                          needs in exit row seats
                                      name: Exit row seat
                                    properties:
                                      designator:
                                        description: >
                                          The designator used to uniquely identify
                                          the seat, usually made up of a 

                                          row number and a column letter
                                        example: 14B
                                        type: string
                                      disclosures:
                                        description: >
                                          Each disclosure is text, in English,
                                          provided by the airline that 

                                          describes the terms and conditions of
                                          this seat. We recommend showing 

                                          this in your user interface to make sure
                                          that customers understand any 

                                          restrictions and limitations.
                                        example:
                                          - Do not seat children in exit row seats
                                          - >-
                                            Do not seat passengers with special
                                            needs in exit row seats
                                        items:
                                          description: >
                                            An individual term, condition or
                                            restriction for this seat
                                          type: string
                                        type: array
                                      name:
                                        description: >
                                          A name which describes the type of seat,
                                          which you can display in your 

                                          user interface to help customers to
                                          understand its features
                                        example: Exit row seat
                                        type:
                                          - string
                                          - 'null'
                                    required:
                                      - designator
                                      - name
                                      - disclosures
                                    title: Service Metadata for a Seat
                                    type: object
                                  - additionalProperties: false
                                    description: >-
                                      An object containing metadata about the
                                      service
                                    properties:
                                      meal:
                                        description: Data about the meal
                                        enum:
                                          - baby_meal
                                          - bland_meal
                                          - asian_vegetarian_meal
                                          - diabetic_meal
                                          - gluten_free_meal
                                          - hindu_meal
                                          - kosher_meal
                                          - muslim_meal
                                          - vegan_meal
                                          - vegetarian_lacto_ovo_meal
                                          - traditional_meal
                                          - low_fat_meal
                                          - low_salt_meal
                                          - lactose_free_meal
                                          - healthy_meal
                                          - swiss_cold_meal
                                          - swiss_brunch
                                          - japanese_meal
                                          - child_meal
                                          - allergen_meal
                                          - vegetarian_meal
                                          - meal
                                        example: kosher
                                        type: string
                                    required:
                                      - meal
                                    title: Service Metadata for a Meal
                                    type: object
                                  - additionalProperties: false
                                    description: >-
                                      An object containing metadata about the
                                      service
                                    properties:
                                      merchant_copy:
                                        description: >-
                                          Details of what this CFAR service
                                          entails and how it can be used
                                        example: >
                                          If you purchase this product we can
                                          refund up to 75% of your base fare if
                                          you cancel 24 hours before your first
                                          scheduled departure
                                        type: string
                                      refund_amount:
                                        description: >-
                                          The amount of money that will be
                                          returned
                                        example: '90.80'
                                        type: string
                                      terms_and_conditions_url:
                                        description: >-
                                          The URL where you can find the terms and
                                          conditions for this CFAR service
                                        example: >-
                                          https://duffel.com/cfar_terms_and_conditions
                                        type: string
                                    required:
                                      - refund_amount
                                      - terms_and_conditions_url
                                      - merchant_copy
                                    title: Service Metadata for Cancel for Any Reason
                                    type: object
                              passenger_ids:
                                description: >-
                                  The list of passenger `id`s the service
                                  applies to. If you add this service to an
                                  order it will apply to all the passengers in
                                  this list. For services where the type is
                                  `baggage`, this list will include only a
                                  single passenger.
                                example:
                                  - pas_00009hj8USM7Ncg31cBCLL
                                items:
                                  type: string
                                type: array
                              segment_ids:
                                description: >-
                                  The list of segment `id`s the service applies
                                  to. If you add this service to an order it
                                  will apply to all the segments in this list.
                                  For services where the type is `baggage`,
                                  depending on the airline, this list includes
                                  all the segments of all slices or all the
                                  segments of a single slice.
                                example:
                                  - seg_00009hj8USM7Ncg31cB456
                                items:
                                  type: string
                                type: array
                              total_amount:
                                description: >
                                  The total price of the service for all
                                  passengers and segments it

                                  applies to, including taxes. This price is for
                                  a single unit of the

                                  service.
                                example: '15.00'
                                type: string
                              total_currency:
                                description: >
                                  The currency of the `total_amount`, as an [ISO
                                  4217](https://en.wikipedia.org/wiki/ISO_4217)
                                  currency code.

                                  If an offer or order is priced with balance,
                                  it matches your organisation's billing
                                  currency. If it is priced with card or airline
                                  credit, it is returned in the currency the
                                  airline charges in. If it is priced without
                                  payment methods and not using Duffel Content,
                                  it is returned in the agency point of sale
                                  currency.
                                example: GBP
                                format: ISO 4217
                                type: string
                              type:
                                description: The type of the service
                                enum:
                                  - baggage
                                  - seat
                                  - meal
                                  - cancel_for_any_reason
                                example: baggage
                                type: string
                            title: Offer Service
                            type: object
                          type: array
                        base_amount:
                          description: >-
                            The base price of the offer for all passengers,
                            excluding taxes. It does not include the base amount
                            of any service(s) that might be booked with the
                            offer.
                          example: '30.20'
                          type: string
                        base_currency:
                          description: >
                            The currency of the `base_amount`, as an [ISO
                            4217](https://en.wikipedia.org/wiki/ISO_4217)
                            currency code.

                            It will match your organisation's billing currency
                            unless you’re using Duffel as an accredited IATA
                            agent, in which case it will be in the currency
                            provided by the airline (which will usually be based
                            on the country where your IATA agency is
                            registered).
                          example: GBP
                          format: ISO 4217
                          type: string
                        conditions:
                          description: >
                            The conditions associated with this offer,
                            describing the kinds of modifications you can make
                            post-booking and any penalties that will apply to
                            those modifications.

                            This information assumes the condition is applied to
                            all of the slices and passengers associated with
                            this offer - for information at the slice level
                            (e.g. "what happens if I just want to change the
                            first slice?") refer to the `slices`.

                            If a particular kind of modification is allowed, you
                            may not always be able to take action through the
                            Duffel API. In some cases, you may need to contact
                            the Duffel support team or the airline directly.
                          properties:
                            change_before_departure:
                              description: >
                                Whether the whole offer can be changed before
                                the departure of the first slice.

                                If all of the slices on the offer can be changed
                                then the `allowed` property will be `true`.
                                Refer to the `slices` for information about
                                change penalties.

                                If any of the slices on the offer can't be
                                changed then the `allowed` property will be
                                `false`. In this case you should refer to the
                                `slices` conditions to determine if any part of
                                the offer is changeable.

                                If the airline hasn't provided any information
                                about whether this offer can be changed then
                                this property will be `null`.
                              properties:
                                allowed:
                                  description: >-
                                    Whether this kind of modification is allowed
                                    post-booking
                                  example: true
                                  type: boolean
                                penalty_amount:
                                  description: >
                                    If the modification is `allowed` then this
                                    is the amount payable to apply the
                                    modification to all passengers. If there is
                                    no penalty, the value will be zero.

                                    If the modification isn't `allowed` or the
                                    penalty is not known then this field will be
                                    `null`.

                                    If this is `null` then the
                                    `penalty_currency` will also be `null`.
                                  example: '100.00'
                                  type:
                                    - string
                                    - 'null'
                                penalty_currency:
                                  description: >
                                    The currency of the `penalty_amount` as an
                                    [ISO
                                    4217](https://en.wikipedia.org/wiki/ISO_4217)
                                    currency code.

                                    This will be in a currency determined by the
                                    airline, which is not necessarily the same
                                    as the currency of the offer or order.

                                    If this is `null` then `penalty_amount` will
                                    also be `null`.
                                  example: GBP
                                  format: ISO 4217
                                  type:
                                    - string
                                    - 'null'
                              type:
                                - object
                                - 'null'
                            refund_before_departure:
                              description: >
                                Whether the whole offer can be refunded before
                                the departure of the first slice.

                                If all of the slices on the offer can be
                                refunded then the `allowed` property will be
                                `true` and information will be provided about
                                any penalties.

                                If any of the slices on the offer can't be
                                refunded then the `allowed` property will be
                                `false`.

                                If the airline hasn't provided any information
                                about whether this offer can be refunded then
                                this property will be `null`.
                              properties:
                                allowed:
                                  description: >-
                                    Whether this kind of modification is allowed
                                    post-booking
                                  example: true
                                  type: boolean
                                penalty_amount:
                                  description: >
                                    If the modification is `allowed` then this
                                    is the amount payable to apply the
                                    modification to all passengers. If there is
                                    no penalty, the value will be zero.

                                    If the modification isn't `allowed` or the
                                    penalty is not known then this field will be
                                    `null`.

                                    If this is `null` then the
                                    `penalty_currency` will also be `null`.
                                  example: '100.00'
                                  type:
                                    - string
                                    - 'null'
                                penalty_currency:
                                  description: >
                                    The currency of the `penalty_amount` as an
                                    [ISO
                                    4217](https://en.wikipedia.org/wiki/ISO_4217)
                                    currency code.

                                    This will be in a currency determined by the
                                    airline, which is not necessarily the same
                                    as the currency of the offer or order.

                                    If this is `null` then `penalty_amount` will
                                    also be `null`.
                                  example: GBP
                                  format: ISO 4217
                                  type:
                                    - string
                                    - 'null'
                              type:
                                - object
                                - 'null'
                          title: OfferConditions
                          type: object
                        created_at:
                          description: >-
                            The [ISO
                            8601](https://en.wikipedia.org/wiki/ISO_8601)
                            datetime at which the offer was created
                          example: '2020-01-17T10:12:14.545Z'
                          format: date-time
                          type: string
                        expires_at:
                          description: >-
                            The [ISO
                            8601](https://en.wikipedia.org/wiki/ISO_8601)
                            datetime expiry of the offer before which the
                            traveller should use this offer to create an order.
                            After this time the offer can no longer be used to
                            create an order.
                          example: '2020-01-17T10:42:14.545Z'
                          format: date-time
                          type: string
                        id:
                          description: Duffel's unique identifier for the resource
                          example: off_00009htYpSCXrwaB9DnUm0
                          type: string
                        intended_payment_methods:
                          description: >-
                            The payment methods that will be used to pay for the
                            offer and their fees if any.
                          items:
                            oneOf:
                              - additionalProperties: false
                                properties:
                                  card_id:
                                    description: The ID of the card you intend to pay with
                                    example: tcd_0000A3t2sL46m5eDF45kWW
                                    type: string
                                  charge_amount:
                                    description: >-
                                      The amount that will be charged to the
                                      card payment
                                    example: '500.20'
                                    type: string
                                  charge_currency:
                                    description: The currency of the charge amount
                                    example: GBP
                                    format: ISO 4217
                                    type: string
                                  surcharge_amount:
                                    description: >-
                                      The surcharge amount that will be applied
                                      to the card payment
                                    example: '30.20'
                                    type:
                                      - string
                                      - 'null'
                                  surcharge_currency:
                                    description: The currency of the surcharge amount
                                    example: GBP
                                    format: ISO 4217
                                    type:
                                      - string
                                      - 'null'
                                  type:
                                    description: >-
                                      The type of payment method you intend to
                                      use
                                    enum:
                                      - card
                                    example: card
                                    type: string
                                required:
                                  - type
                                  - card_id
                                  - charge_amount
                                  - charge_currency
                                  - surcharge_amount
                                  - surcharge_currency
                                title: Intended Card Surcharge
                                type: object
                              - additionalProperties: false
                                properties:
                                  airline_credit_id:
                                    description: >-
                                      The ID of the airilne credit you intend to
                                      pay with
                                    example: tcd_0000A3t2sL46m5eDF45kWW
                                    type: string
                                  charge_amount:
                                    description: >-
                                      The amount that will be taken from this
                                      airline credit
                                    example: '30.20'
                                    type: string
                                  charge_currency:
                                    description: The currency of the charge amount
                                    example: GBP
                                    format: ISO 4217
                                    type: string
                                  penalty_amount:
                                    description: >-
                                      The penalty that will be incurred when
                                      paying with this airline credit
                                    example: '10.20'
                                    type: string
                                  penalty_currency:
                                    description: The currency of the penalty amount
                                    example: GBP
                                    format: ISO 4217
                                    type: string
                                  type:
                                    description: >-
                                      The type of payment method you intend to
                                      use
                                    enum:
                                      - airline_credit
                                    example: airline_credit
                                    type: string
                                required:
                                  - type
                                  - airline_credit_id
                                  - charge_amount
                                  - charge_currency
                                  - penalty_amount
                                  - penalty_currency
                                title: Intended Airline Credit Charge
                                type: object
                          type: array
                        intended_services:
                          description: The services that will be booked with the offer.
                          items:
                            additionalProperties: false
                            properties:
                              id:
                                description: Duffel's unique identifier for the resource
                                example: ase_00009UhD4ongolulWd9123
                                type: string
                              quantity:
                                description: >-
                                  The quantity of the service you intend to
                                  book. This will always be `1` for seat
                                  services.
                                example: 1
                                minimum: 1
                                type: integer
                            required:
                              - id
                              - quantity
                            title: Intended Service
                            type: object
                          type: array
                        live_mode:
                          description: >-
                            Whether the offer request was created in live mode.
                            This field will be set to `true` if the offer
                            request was created in live mode, or `false` if it
                            was created in test mode.
                          example: true
                          type: boolean
                        owner:
                          allOf:
                            - additionalProperties: false
                              properties:
                                conditions_of_carriage_url:
                                  description: URL to the airline's conditions of carriage.
                                  example: >-
                                    https://www.britishairways.com/en-gb/information/legal/british-airways/general-conditions-of-carriage
                                  type:
                                    - string
                                    - 'null'
                                iata_code:
                                  description: >-
                                    The two-character IATA code for the airline.
                                    This may be `null` for non-IATA carriers.
                                  example: BA
                                  type:
                                    - string
                                    - 'null'
                                id:
                                  description: Duffel's unique identifier for the airline
                                  example: arl_00001876aqC8c5umZmrRds
                                  type: string
                                logo_lockup_url:
                                  description: >-
                                    Path to a svg of the airline lockup logo.

                                    A lockup logo is also called a combination
                                    logo, in which it combines the logotype and
                                    logomark.

                                    This may be `null` if no logo is available.
                                  example: >-
                                    https://assets.duffel.com/img/airlines/for-light-background/full-color-lockup/BA.svg
                                  type:
                                    - string
                                    - 'null'
                                logo_symbol_url:
                                  description: |-
                                    Path to a svg of the airline logo.
                                    This may be `null` if no logo is available.
                                  example: >-
                                    https://assets.duffel.com/img/airlines/for-light-background/full-color-logo/BA.svg
                                  type:
                                    - string
                                    - 'null'
                                name:
                                  description: The name of the airline
                                  example: British Airways
                                  type: string
                              title: Airline
                              type: object
                            - description: The airline which provided the offer
                        partial:
                          description: >
                            Partial offers are a new concept we're introducing
                            as a part of a new multi-step search flow that we're
                            currently experimenting with.

                            A partial offer can't be booked directly, but it can
                            be combined with other partial offers to form a full
                            offer.

                            Partial offers are only ever returned through the
                            multi-step search flow. So there's no need to add
                            any handling to deal with partial offers if you're
                            using the traditional `OfferRequest` search flow to
                            create offers.
                          example: true
                          type: boolean
                        passenger_identity_documents_required:
                          description: >-
                            Whether identity documents must be provided for each
                            of the passengers when creating an order based on
                            this offer. If this is `true`, you must provide a
                            passport document for every passenger.
                          example: false
                          type: boolean
                        passengers:
                          description: The passengers included in the offer
                          items:
                            properties:
                              age:
                                description: >-
                                  The age of the passenger on the
                                  `departure_date` of the final slice
                                example: 14
                                maximum: 130
                                minimum: 0
                                type:
                                  - integer
                                  - 'null'
                              family_name:
                                description: The passenger's family name
                                example: Earhart
                                type:
                                  - string
                                  - 'null'
                              fare_type:
                                description: The fare type of the passenger
                                example: contract_bulk
                                type:
                                  - string
                                  - 'null'
                              given_name:
                                description: The passenger's given name
                                example: Amelia
                                type:
                                  - string
                                  - 'null'
                              id:
                                description: >-
                                  The identifier for the passenger. This ID will
                                  be generated by Duffel
                                example: pas_00009hj8USM7Ncg31cBCL
                                type: string
                              loyalty_programme_accounts:
                                description: >-
                                  The loyalty programme accounts for this
                                  passenger
                                items:
                                  properties:
                                    account_number:
                                      description: >-
                                        The passenger's account number for this
                                        loyalty programme account
                                      example: '12901014'
                                      type: string
                                    airline_iata_code:
                                      description: >-
                                        The IATA code for the airline that this
                                        loyalty programme account belongs to
                                      example: BA
                                      type: string
                                  title: Loyalty Programme Account
                                  type: object
                                type: array
                              type:
                                description: The type of the passenger
                                enum:
                                  - adult
                                  - child
                                  - infant_without_seat
                                example: adult
                                type:
                                  - string
                                  - 'null'
                            title: Offer Passenger
                            type: object
                          type: array
                        payment_requirements:
                          allOf:
                            - properties:
                                payment_required_by:
                                  description: >
                                    The [ISO
                                    8601](https://en.wikipedia.org/wiki/ISO_8601)
                                    datetime by which you must pay for this
                                    offer. At this time, if still unpaid, the
                                    reserved space on the flight(s) will be
                                    released and you will have to create a new
                                    order.

                                    This will be `null` when the offer requires
                                    immediate payment - that is, when
                                    `requires_instant_payment` is `true`.
                                  example: '2020-01-17T10:42:14Z'
                                  format: date-time
                                  type:
                                    - string
                                    - 'null'
                                price_guarantee_expires_at:
                                  description: >
                                    The [ISO
                                    8601](https://en.wikipedia.org/wiki/ISO_8601)
                                    datetime at which the price associated with
                                    the order will no longer be guaranteed by
                                    the airline and may change before payment.

                                    This will be `null` when
                                    `requires_instant_payment` is `true`.
                                  example: '2020-01-17T10:42:14Z'
                                  format: date-time
                                  type:
                                    - string
                                    - 'null'
                                requires_instant_payment:
                                  description: >
                                    When payment is required at the time of
                                    booking this will be `true` and
                                    `payment_required_by` and
                                    `price_guarantee_expires_at` will be `null`.
                                    When payment can be made at a time after
                                    booking, this will be `false` and the time
                                    limits on the payment will be provided in
                                    `payment_required_by` and
                                    `price_guarantee_expires_at`.
                                  example: false
                                  type: boolean
                              title: OfferPaymentRequirements
                              type: object
                            - description: The payment requirements for this offer
                        private_fares:
                          description: The private fares applied on this offer.
                          items:
                            properties:
                              corporate_code:
                                description: The corporate code that was applied, if any
                                example: FLX53
                                type:
                                  - string
                                  - 'null'
                              tour_code:
                                description: The tour code that was applied, if any
                                example: 578DFL
                                type:
                                  - string
                                  - 'null'
                              tracking_reference:
                                description: >-
                                  The tracking reference that was applied, if
                                  any
                                example: ABN:2345678
                                type:
                                  - string
                                  - 'null'
                              type:
                                description: The type of private fare applied
                                enum:
                                  - corporate
                                  - leisure
                                  - negotiated
                                example: corporate
                                type: string
                            required:
                              - type
                              - corporate_code
                              - tracking_reference
                              - tour_code
                            title: Offer Private Fares
                            type: object
                          type: array
                        slices:
                          description: >
                            The [slices](/docs/api/overview/key-concepts) that
                            make up this offer. Each slice will include one or
                            more [segments](/docs/api/overview/key-concepts),
                            the specific flights that the airline is offering to
                            take the passengers from the slice's `origin` to its
                            `destination`.

                            [Partial](#offers-schema-partial) offers contain a
                            single slice as each partial offer is for a
                            particular slice of the journey.
                          items:
                            properties:
                              comparison_key:
                                description: >-
                                  A hash uniquely identifying this slice. This
                                  value could be use to group together identical
                                  slices from different offers.
                                example: BmlZDw==
                                type: string
                              conditions:
                                description: >
                                  The conditions associated with this slice,
                                  describing the kinds of

                                  modifications you can make post-booking and
                                  any penalties that

                                  will apply to those modifications and also
                                  what perks will

                                  be available to passengers when travelling.


                                  This condition is applied only to this slice
                                  and to all the passengers

                                  associated with this offer - for information
                                  at the offer level

                                  (e.g. "what happens if I want to change all
                                  the slices?") refer to the

                                  `conditions` at the top level.


                                  If a particular kind of modification is
                                  allowed, you may not always be able to take
                                  action through

                                  the Duffel API. In some cases, you may need to
                                  contact the Duffel support team or

                                  the airline directly.


                                  Note that the perks associated with the slice
                                  are aggregated across passengers

                                  and segments and are intended to provide a
                                  brief summary of the passenger experience,
                                  however

                                  the experience may not be consistent across
                                  all segments. As an example, priority boarding
                                  may

                                  be flagged as available on the slice but not
                                  available on all segments on the slice.


                                  **Note**: `advance_seat_selection`,
                                  `priority_boarding` and `priority_check_in`
                                  are under restricted `NGS` feature.

                                  If you need access, get in touch with the
                                  Duffel support team.
                                properties:
                                  advance_seat_selection:
                                    description: >-
                                      Whether passengers are able to select a
                                      seat prior to check in.
                                    example: 'true'
                                    type:
                                      - boolean
                                      - 'null'
                                  change_before_departure:
                                    description: >
                                      Whether this slice can be changed before
                                      the departure.

                                      If the slice can be changed for all of the
                                      passengers then the `allowed` property
                                      will be `true` and information will be
                                      provided about any penalties.

                                      If none of the passengers on the slice can
                                      be changed then the `allowed` property
                                      will be `false`.

                                      In all other cases this property will be
                                      `null` indicating we can't provide the
                                      information for this slice.

                                      The `penalty_amount` is specific to
                                      changing this slice and may not be the
                                      penalty that is applied if the entire
                                      offer is changed.
                                    properties:
                                      allowed:
                                        description: >-
                                          Whether this kind of modification is
                                          allowed post-booking
                                        example: true
                                        type: boolean
                                      penalty_amount:
                                        description: >
                                          If the modification is `allowed` then
                                          this is the amount payable to apply the
                                          modification to all passengers. If there
                                          is no penalty, the value will be zero.

                                          If the modification isn't `allowed` or
                                          the penalty is not known then this field
                                          will be `null`.

                                          If this is `null` then the
                                          `penalty_currency` will also be `null`.
                                        example: '100.00'
                                        type:
                                          - string
                                          - 'null'
                                      penalty_currency:
                                        description: >
                                          The currency of the `penalty_amount` as
                                          an [ISO
                                          4217](https://en.wikipedia.org/wiki/ISO_4217)
                                          currency code.

                                          This will be in a currency determined by
                                          the airline, which is not necessarily
                                          the same as the currency of the offer or
                                          order.

                                          If this is `null` then `penalty_amount`
                                          will also be `null`.
                                        example: GBP
                                        format: ISO 4217
                                        type:
                                          - string
                                          - 'null'
                                    type:
                                      - object
                                      - 'null'
                                  priority_boarding:
                                    description: >-
                                      Whether passengers are given preferential
                                      boarding over other passengers in their
                                      cabin.
                                    example: 'true'
                                    type:
                                      - boolean
                                      - 'null'
                                  priority_check_in:
                                    description: >-
                                      Whether passengers are given access to a
                                      fast track lane during check in.
                                    example: 'true'
                                    type:
                                      - boolean
                                      - 'null'
                                title: OfferSliceConditions
                                type: object
                              destination:
                                allOf:
                                  - additionalProperties: false
                                    properties:
                                      airports:
                                        description: >-
                                          The airports associated to a city. This
                                          will only be provided where the `type`
                                          is `city`.
                                        items:
                                          properties:
                                            city:
                                              description: >-
                                                The metropolitan area where the airport
                                                is located. Only present for airports
                                                which are registered with IATA as
                                                belonging to a [metropolitan
                                                area](https://portal.iata.org/faq/articles/en_US/FAQ/How-do-I-create-a-new-Metropolitan-Area).
                                              properties:
                                                airports:
                                                  description: >-
                                                    List of airports associated with the
                                                    city
                                                  items:
                                                    properties:
                                                      iata_code:
                                                        description: >-
                                                          The three-character IATA code for the
                                                          airport
                                                        example: LHR
                                                        type: string
                                                      iata_country_code:
                                                        description: >-
                                                          The [ISO 3166-1
                                                          alpha-2](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2)
                                                          code for the country where the airport
                                                          is located
                                                        example: GB
                                                        format: ISO 3166-1 alpha-2
                                                        type: string
                                                      icao_code:
                                                        description: >-
                                                          The four-character ICAO code for the
                                                          airport
                                                        example: EGLL
                                                        type:
                                                          - string
                                                          - 'null'
                                                      id:
                                                        description: >-
                                                          Duffel's unique identifier for the
                                                          resource
                                                        example: arp_lhr_gb
                                                        type: string
                                                      latitude:
                                                        description: >-
                                                          The latitude position of the airport
                                                          represented in [Decimal
                                                          degrees](https://en.wikipedia.org/wiki/Decimal_degrees)
                                                          with 6 decimal points with a range
                                                          between -90° and 90°
                                                        example: 64.068865
                                                        format: float
                                                        type: number
                                                      longitude:
                                                        description: >-
                                                          The longitude position of the airport
                                                          represented in [Decimal
                                                          degrees](https://en.wikipedia.org/wiki/Decimal_degrees)
                                                          with 6 decimal points with a range
                                                          between -180° and 180°
                                                        example: -141.951519
                                                        format: float
                                                        type: number
                                                      name:
                                                        description: The name of the airport
                                                        example: Heathrow
                                                        type: string
                                                      time_zone:
                                                        description: >-
                                                          The time zone of the airport, specified
                                                          by name from the [tz
                                                          database](https://en.wikipedia.org/wiki/Tz_database)
                                                        example: Europe/London
                                                        type: string
                                                    type: object
                                                  type: array
                                                iata_code:
                                                  description: >-
                                                    The three-character IATA code for the
                                                    city
                                                  example: LON
                                                  type: string
                                                iata_country_code:
                                                  description: >-
                                                    The [ISO 3166-1
                                                    alpha-2](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2)
                                                    code for the country where the city is
                                                    located
                                                  example: GB
                                                  format: ISO 3166-1 alpha-2
                                                  type: string
                                                id:
                                                  description: >-
                                                    Duffel's unique identifier for the
                                                    resource
                                                  example: cit_lon_gb
                                                  type: string
                                                name:
                                                  description: The name of the city
                                                  example: London
                                                  type: string
                                              title: City
                                              type:
                                                - object
                                                - 'null'
                                            city_name:
                                              description: >-
                                                The name of the city (or cities
                                                separated by a `/`) where the airport is
                                                located
                                              example: London
                                              type: string
                                            iata_city_code:
                                              description: >-
                                                The three-character IATA code for the
                                                city where the airport is located
                                              example: LON
                                              type: string
                                            iata_code:
                                              description: >-
                                                The three-character IATA code for the
                                                airport
                                              example: LHR
                                              type: string
                                            iata_country_code:
                                              description: >-
                                                The [ISO 3166-1
                                                alpha-2](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2)
                                                code for the country where the airport
                                                is located
                                              example: GB
                                              format: ISO 3166-1 alpha-2
                                              type: string
                                            icao_code:
                                              description: >-
                                                The four-character ICAO code for the
                                                airport
                                              example: EGLL
                                              type:
                                                - string
                                                - 'null'
                                            id:
                                              description: >-
                                                Duffel's unique identifier for the
                                                resource
                                              example: arp_lhr_gb
                                              type: string
                                            latitude:
                                              description: >-
                                                The latitude position of the airport
                                                represented in [Decimal
                                                degrees](https://en.wikipedia.org/wiki/Decimal_degrees)
                                                with 6 decimal points with a range
                                                between -90° and 90°
                                              example: 64.068865
                                              format: float
                                              type: number
                                            longitude:
                                              description: >-
                                                The longitude position of the airport
                                                represented in [Decimal
                                                degrees](https://en.wikipedia.org/wiki/Decimal_degrees)
                                                with 6 decimal points with a range
                                                between -180° and 180°
                                              example: -141.951519
                                              format: float
                                              type: number
                                            name:
                                              description: The name of the airport
                                              example: Heathrow
                                              type: string
                                            time_zone:
                                              description: >-
                                                The time zone of the airport, specified
                                                by name from the [tz
                                                database](https://en.wikipedia.org/wiki/Tz_database)
                                              example: Europe/London
                                              type: string
                                          required:
                                            - iata_code
                                            - id
                                            - name
                                            - iata_country_code
                                            - latitude
                                            - longitude
                                            - icao_code
                                            - time_zone
                                            - city_name
                                            - iata_city_code
                                          title: Airport
                                          type: object
                                        type:
                                          - array
                                          - 'null'
                                      city:
                                        description: >-
                                          The metropolitan area where the airport
                                          is located. Only present for airports
                                          which are registered with IATA as
                                          belonging to a [metropolitan
                                          area](https://portal.iata.org/faq/articles/en_US/FAQ/How-do-I-create-a-new-Metropolitan-Area).
                                        properties:
                                          airports:
                                            description: >-
                                              List of airports associated with the
                                              city
                                            items:
                                              properties:
                                                iata_code:
                                                  description: >-
                                                    The three-character IATA code for the
                                                    airport
                                                  example: LHR
                                                  type: string
                                                iata_country_code:
                                                  description: >-
                                                    The [ISO 3166-1
                                                    alpha-2](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2)
                                                    code for the country where the airport
                                                    is located
                                                  example: GB
                                                  format: ISO 3166-1 alpha-2
                                                  type: string
                                                icao_code:
                                                  description: >-
                                                    The four-character ICAO code for the
                                                    airport
                                                  example: EGLL
                                                  type:
                                                    - string
                                                    - 'null'
                                                id:
                                                  description: >-
                                                    Duffel's unique identifier for the
                                                    resource
                                                  example: arp_lhr_gb
                                                  type: string
                                                latitude:
                                                  description: >-
                                                    The latitude position of the airport
                                                    represented in [Decimal
                                                    degrees](https://en.wikipedia.org/wiki/Decimal_degrees)
                                                    with 6 decimal points with a range
                                                    between -90° and 90°
                                                  example: 64.068865
                                                  format: float
                                                  type: number
                                                longitude:
                                                  description: >-
                                                    The longitude position of the airport
                                                    represented in [Decimal
                                                    degrees](https://en.wikipedia.org/wiki/Decimal_degrees)
                                                    with 6 decimal points with a range
                                                    between -180° and 180°
                                                  example: -141.951519
                                                  format: float
                                                  type: number
                                                name:
                                                  description: The name of the airport
                                                  example: Heathrow
                                                  type: string
                                                time_zone:
                                                  description: >-
                                                    The time zone of the airport, specified
                                                    by name from the [tz
                                                    database](https://en.wikipedia.org/wiki/Tz_database)
                                                  example: Europe/London
                                                  type: string
                                              type: object
                                            type: array
                                          iata_code:
                                            description: >-
                                              The three-character IATA code for the
                                              city
                                            example: LON
                                            type: string
                                          iata_country_code:
                                            description: >-
                                              The [ISO 3166-1
                                              alpha-2](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2)
                                              code for the country where the city is
                                              located
                                            example: GB
                                            format: ISO 3166-1 alpha-2
                                            type: string
                                          id:
                                            description: >-
                                              Duffel's unique identifier for the
                                              resource
                                            example: cit_lon_gb
                                            type: string
                                          name:
                                            description: The name of the city
                                            example: London
                                            type: string
                                        title: City
                                        type:
                                          - object
                                          - 'null'
                                      city_name:
                                        description: >-
                                          The name of the city (or cities
                                          separated by a `/`) where the airport is
                                          located
                                        example: London
                                        type:
                                          - string
                                          - 'null'
                                      iata_city_code:
                                        description: >-
                                          The 3-letter IATA code for the city
                                          where the place is located. Only present
                                          for airports which are registered with
                                          IATA as belonging to a [metropolitan
                                          area](https://portal.iata.org/faq/articles/en_US/FAQ/How-do-I-create-a-new-Metropolitan-Area).
                                        example: LON
                                        type:
                                          - string
                                          - 'null'
                                      iata_code:
                                        description: The 3-letter IATA code for the place
                                        example: LHR
                                        type: string
                                      iata_country_code:
                                        description: >-
                                          The [ISO 3166-1
                                          alpha-2](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2)
                                          code for the country where the city is
                                          located
                                        example: GB
                                        format: ISO 3166-1 alpha-2
                                        type: string
                                      icao_code:
                                        description: >-
                                          The four-character ICAO code for the
                                          airport
                                        example: EGLL
                                        type:
                                          - string
                                          - 'null'
                                      id:
                                        description: >-
                                          Duffel's unique identifier for the
                                          resource
                                        example: arp_lhr_gb
                                        type: string
                                      latitude:
                                        description: >-
                                          The latitude position of the airport
                                          represented in [Decimal
                                          degrees](https://en.wikipedia.org/wiki/Decimal_degrees)
                                          with 6 decimal points with a range
                                          between -90° and 90°
                                        example: 64.068865
                                        format: float
                                        type:
                                          - number
                                          - 'null'
                                      longitude:
                                        description: >-
                                          The longitude position of the airport
                                          represented in [Decimal
                                          degrees](https://en.wikipedia.org/wiki/Decimal_degrees)
                                          with 6 decimal points with a range
                                          between -180° and 180°
                                        example: -141.951519
                                        format: float
                                        type:
                                          - number
                                          - 'null'
                                      name:
                                        description: The name of the place
                                        example: Heathrow
                                        type: string
                                      time_zone:
                                        description: >-
                                          The time zone of the airport, specified
                                          by name from the [tz
                                          database](https://en.wikipedia.org/wiki/Tz_database)
                                        example: Europe/London
                                        type:
                                          - string
                                          - 'null'
                                      type:
                                        description: The type of the place
                                        enum:
                                          - airport
                                          - city
                                        example: airport
                                        type: string
                                    required:
                                      - iata_city_code
                                      - iata_code
                                      - id
                                      - name
                                      - type
                                      - iata_country_code
                                      - latitude
                                      - longitude
                                      - icao_code
                                      - time_zone
                                      - city_name
                                    title: Place
                                    type: object
                                  - description: The city or airport where this slice ends
                              destination_type:
                                description: The type of the destination
                                enum:
                                  - airport
                                  - city
                                example: airport
                                type: string
                              duration:
                                description: >-
                                  The duration of the slice, represented as a
                                  [ISO
                                  8601](https://en.wikipedia.org/wiki/ISO_8601#Durations)
                                  duration
                                example: PT02H26M
                                type:
                                  - string
                                  - 'null'
                              fare_brand_name:
                                description: >
                                  The name of the fare brand associated with
                                  this slice.

                                  A fare brand specifies the travel conditions
                                  you get on your slice made available by the
                                  airline.

                                  e.g. a British Airways Economy Basic fare will
                                  only include a hand baggage allowance.

                                  It is worth noting that the fare brand names
                                  are defined by the airlines themselves and

                                  therefore they are subject to change without
                                  any prior notice.

                                  We’re in the process of adding support for
                                  `fare_brand_name` across all our airlines,

                                  so for now, this field may be `null` in some
                                  offers.

                                  This will become a non-nullable attribute in
                                  the near future.
                                example: Basic
                                type:
                                  - string
                                  - 'null'
                              id:
                                description: Duffel's unique identifier for the resource
                                example: sli_00009htYpSCXrwaB9Dn123
                                type: string
                              ngs_shelf:
                                description: >
                                  A summary of the seat characteristics and
                                  extras available to passengers on the given
                                  slice.


                                  The shelf is calculated by Duffel and may be
                                  used to group similar slices across offers
                                  when building a shopping display.


                                  Note this value does not take into account any
                                  services that may be purchased in addition to
                                  the offer and should not be directly used

                                  in any offer ranking systems.


                                  Includes the following:

                                    - `1`: standard seating with limited extras.
                                    - `2`: standard seating with extras, i.e. carry-on baggage, advanced seat selection,  priority boarding etc.
                                    - `3`: preferred seating, such as additional legroom, seat width or middle seat free
                                    - `4`: premium seating, additional legroom and recline. Situated in business class or higher.
                                    - `5`: deluxe seating, additional legroom and reclines to lie flat position. Situated in business class or higher.

                                  **Note**: this field is under restricted `NGS`
                                  feature. If you need access, get in touch with
                                  the Duffel support team.
                                enum:
                                  - 1
                                  - 2
                                  - 3
                                  - 4
                                  - 5
                                example: 1
                                type:
                                  - integer
                                  - 'null'
                              origin:
                                allOf:
                                  - additionalProperties: false
                                    properties:
                                      airports:
                                        description: >-
                                          The airports associated to a city. This
                                          will only be provided where the `type`
                                          is `city`.
                                        items:
                                          properties:
                                            city:
                                              description: >-
                                                The metropolitan area where the airport
                                                is located. Only present for airports
                                                which are registered with IATA as
                                                belonging to a [metropolitan
                                                area](https://portal.iata.org/faq/articles/en_US/FAQ/How-do-I-create-a-new-Metropolitan-Area).
                                              properties:
                                                airports:
                                                  description: >-
                                                    List of airports associated with the
                                                    city
                                                  items:
                                                    properties:
                                                      iata_code:
                                                        description: >-
                                                          The three-character IATA code for the
                                                          airport
                                                        example: LHR
                                                        type: string
                                                      iata_country_code:
                                                        description: >-
                                                          The [ISO 3166-1
                                                          alpha-2](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2)
                                                          code for the country where the airport
                                                          is located
                                                        example: GB
                                                        format: ISO 3166-1 alpha-2
                                                        type: string
                                                      icao_code:
                                                        description: >-
                                                          The four-character ICAO code for the
                                                          airport
                                                        example: EGLL
                                                        type:
                                                          - string
                                                          - 'null'
                                                      id:
                                                        description: >-
                                                          Duffel's unique identifier for the
                                                          resource
                                                        example: arp_lhr_gb
                                                        type: string
                                                      latitude:
                                                        description: >-
                                                          The latitude position of the airport
                                                          represented in [Decimal
                                                          degrees](https://en.wikipedia.org/wiki/Decimal_degrees)
                                                          with 6 decimal points with a range
                                                          between -90° and 90°
                                                        example: 64.068865
                                                        format: float
                                                        type: number
                                                      longitude:
                                                        description: >-
                                                          The longitude position of the airport
                                                          represented in [Decimal
                                                          degrees](https://en.wikipedia.org/wiki/Decimal_degrees)
                                                          with 6 decimal points with a range
                                                          between -180° and 180°
                                                        example: -141.951519
                                                        format: float
                                                        type: number
                                                      name:
                                                        description: The name of the airport
                                                        example: Heathrow
                                                        type: string
                                                      time_zone:
                                                        description: >-
                                                          The time zone of the airport, specified
                                                          by name from the [tz
                                                          database](https://en.wikipedia.org/wiki/Tz_database)
                                                        example: Europe/London
                                                        type: string
                                                    type: object
                                                  type: array
                                                iata_code:
                                                  description: >-
                                                    The three-character IATA code for the
                                                    city
                                                  example: LON
[...]
